'use strict';

const TimedPromise = require('liqd-timed-promise');

const Components =
{
  worker: require('./components/worker'),
  listener: require('./components/listener'),
  connection: require('./components/connection'),
};

process.on( 'message', async( msg ) =>
{
  if( msg.spawn )
  {
    let clazz = require( msg.spawn.script );

    if( !Components[msg.spawn.type].has( clazz.name ) )
    {
      new clazz( msg.spawn.options );
    }
  }
  else if( msg.call )
  {
    console.log('volanicko');

    return Components.worker.get( msg.call.worker, true )[msg.call.method](...msg.call.args);
  }
  else
  {
    console.log( 'Process message', msg );
  }
});

require('./helpers/stats').watch( stats => process.send({ stats }) );
